diff -urNp linux-2.6.32.24/net/wireless/wext.c linux-2.6.32.24/net/wireless/wext.c
--- linux-2.6.32.24/net/wireless/wext.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/net/wireless/wext.c	2010-09-23 19:57:05.000000000 -0400
@@ -816,8 +816,7 @@ static int ioctl_standard_iw_point(struc
 		 */
 
 		/* Support for very large requests */
-		if ((descr->flags & IW_DESCR_FLAG_NOMAX) &&
-		    (user_length > descr->max_tokens)) {
+		if (user_length > descr->max_tokens) {
 			/* Allow userspace to GET more than max so
 			 * we can support any size GET requests.
 			 * There is still a limit : -ENOMEM.
@@ -854,22 +853,6 @@ static int ioctl_standard_iw_point(struc
 		}
 	}
 
-	if (IW_IS_GET(cmd) && !(descr->flags & IW_DESCR_FLAG_NOMAX)) {
-		/*
-		 * If this is a GET, but not NOMAX, it means that the extra
-		 * data is not bounded by userspace, but by max_tokens. Thus
-		 * set the length to max_tokens. This matches the extra data
-		 * allocation.
-		 * The driver should fill it with the number of tokens it
-		 * provided, and it may check iwp->length rather than having
-		 * knowledge of max_tokens. If the driver doesn't change the
-		 * iwp->length, this ioctl just copies back max_token tokens
-		 * filled with zeroes. Hopefully the driver isn't claiming
-		 * them to be valid data.
-		 */
-		iwp->length = descr->max_tokens;
-	}
-
 	err = handler(dev, info, (union iwreq_data *) iwp, extra);
 
 	iwp->length += essid_compat;
diff -urNp linux-2.6.32.24/net/xfrm/xfrm_policy.c linux-2.6.32.24/net/xfrm/xfrm_policy.c
--- linux-2.6.32.24/net/xfrm/xfrm_policy.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/net/xfrm/xfrm_policy.c	2010-09-04 15:54:52.000000000 -0400
@@ -1477,7 +1477,7 @@ free_dst:
 	goto out;
 }
 
-static int inline
+static inline int
 xfrm_dst_alloc_copy(void **target, void *src, int size)
 {
 	if (!*target) {
@@ -1489,7 +1489,7 @@ xfrm_dst_alloc_copy(void **target, void 
 	return 0;
 }
 
-static int inline
+static inline int
 xfrm_dst_update_parent(struct dst_entry *dst, struct xfrm_selector *sel)
 {
 #ifdef CONFIG_XFRM_SUB_POLICY
@@ -1501,7 +1501,7 @@ xfrm_dst_update_parent(struct dst_entry 
 #endif
 }
 
-static int inline
+static inline int
 xfrm_dst_update_origin(struct dst_entry *dst, struct flowi *fl)
 {
 #ifdef CONFIG_XFRM_SUB_POLICY
diff -urNp linux-2.6.32.24/samples/kobject/kset-example.c linux-2.6.32.24/samples/kobject/kset-example.c
--- linux-2.6.32.24/samples/kobject/kset-example.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/samples/kobject/kset-example.c	2010-09-04 15:54:52.000000000 -0400
@@ -87,7 +87,7 @@ static ssize_t foo_attr_store(struct kob
 }
 
 /* Our custom sysfs_ops that we will associate with our ktype later on */
-static struct sysfs_ops foo_sysfs_ops = {
+static const struct sysfs_ops foo_sysfs_ops = {
 	.show = foo_attr_show,
 	.store = foo_attr_store,
 };
diff -urNp linux-2.6.32.24/scripts/basic/fixdep.c linux-2.6.32.24/scripts/basic/fixdep.c
--- linux-2.6.32.24/scripts/basic/fixdep.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/basic/fixdep.c	2010-09-04 15:54:52.000000000 -0400
@@ -222,9 +222,9 @@ static void use_config(char *m, int slen
 
 static void parse_config_file(char *map, size_t len)
 {
-	int *end = (int *) (map + len);
+	unsigned int *end = (unsigned int *) (map + len);
 	/* start at +1, so that p can never be < map */
-	int *m   = (int *) map + 1;
+	unsigned int *m   = (unsigned int *) map + 1;
 	char *p, *q;
 
 	for (; m < end; m++) {
@@ -371,7 +371,7 @@ static void print_deps(void)
 static void traps(void)
 {
 	static char test[] __attribute__((aligned(sizeof(int)))) = "CONF";
-	int *p = (int *)test;
+	unsigned int *p = (unsigned int *)test;
 
 	if (*p != INT_CONF) {
 		fprintf(stderr, "fixdep: sizeof(int) != 4 or wrong endianess? %#x\n",
diff -urNp linux-2.6.32.24/scripts/kallsyms.c linux-2.6.32.24/scripts/kallsyms.c
--- linux-2.6.32.24/scripts/kallsyms.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/kallsyms.c	2010-09-04 15:54:52.000000000 -0400
@@ -43,10 +43,10 @@ struct text_range {
 
 static unsigned long long _text;
 static struct text_range text_ranges[] = {
-	{ "_stext",     "_etext"     },
-	{ "_sinittext", "_einittext" },
-	{ "_stext_l1",  "_etext_l1"  },	/* Blackfin on-chip L1 inst SRAM */
-	{ "_stext_l2",  "_etext_l2"  },	/* Blackfin on-chip L2 SRAM */
+	{ "_stext",     "_etext",     0, 0 },
+	{ "_sinittext", "_einittext", 0, 0 },
+	{ "_stext_l1",  "_etext_l1",  0, 0 },	/* Blackfin on-chip L1 inst SRAM */
+	{ "_stext_l2",  "_etext_l2",  0, 0 },	/* Blackfin on-chip L2 SRAM */
 };
 #define text_range_text     (&text_ranges[0])
 #define text_range_inittext (&text_ranges[1])
diff -urNp linux-2.6.32.24/scripts/mod/file2alias.c linux-2.6.32.24/scripts/mod/file2alias.c
--- linux-2.6.32.24/scripts/mod/file2alias.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/mod/file2alias.c	2010-09-04 15:54:52.000000000 -0400
@@ -72,7 +72,7 @@ static void device_id_check(const char *
 			    unsigned long size, unsigned long id_size,
 			    void *symval)
 {
-	int i;
+	unsigned int i;
 
 	if (size % id_size || size < id_size) {
 		if (cross_build != 0)
@@ -102,7 +102,7 @@ static void device_id_check(const char *
 /* USB is special because the bcdDevice can be matched against a numeric range */
 /* Looks like "usb:vNpNdNdcNdscNdpNicNiscNipN" */
 static void do_usb_entry(struct usb_device_id *id,
-			 unsigned int bcdDevice_initial, int bcdDevice_initial_digits,
+			 unsigned int bcdDevice_initial, unsigned int bcdDevice_initial_digits,
 			 unsigned char range_lo, unsigned char range_hi,
 			 struct module *mod)
 {
@@ -368,7 +368,7 @@ static void do_pnp_device_entry(void *sy
 	for (i = 0; i < count; i++) {
 		const char *id = (char *)devs[i].id;
 		char acpi_id[sizeof(devs[0].id)];
-		int j;
+		unsigned int j;
 
 		buf_printf(&mod->dev_table_buf,
 			   "MODULE_ALIAS(\"pnp:d%s*\");\n", id);
@@ -398,7 +398,7 @@ static void do_pnp_card_entries(void *sy
 
 		for (j = 0; j < PNP_MAX_DEVICES; j++) {
 			const char *id = (char *)card->devs[j].id;
-			int i2, j2;
+			unsigned int i2, j2;
 			int dup = 0;
 
 			if (!id[0])
@@ -424,7 +424,7 @@ static void do_pnp_card_entries(void *sy
 			/* add an individual alias for every device entry */
 			if (!dup) {
 				char acpi_id[sizeof(card->devs[0].id)];
-				int k;
+				unsigned int k;
 
 				buf_printf(&mod->dev_table_buf,
 					   "MODULE_ALIAS(\"pnp:d%s*\");\n", id);
@@ -699,7 +699,7 @@ static void dmi_ascii_filter(char *d, co
 static int do_dmi_entry(const char *filename, struct dmi_system_id *id,
 			char *alias)
 {
-	int i, j;
+	unsigned int i, j;
 
 	sprintf(alias, "dmi*");
 
diff -urNp linux-2.6.32.24/scripts/mod/modpost.c linux-2.6.32.24/scripts/mod/modpost.c
--- linux-2.6.32.24/scripts/mod/modpost.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/mod/modpost.c	2010-09-04 15:54:52.000000000 -0400
@@ -835,6 +835,7 @@ enum mismatch {
 	INIT_TO_EXIT,
 	EXIT_TO_INIT,
 	EXPORT_TO_INIT_EXIT,
+	DATA_TO_TEXT
 };
 
 struct sectioncheck {
@@ -920,6 +921,12 @@ const struct sectioncheck sectioncheck[]
 	.fromsec = { "__ksymtab*", NULL },
 	.tosec   = { INIT_SECTIONS, EXIT_SECTIONS, NULL },
 	.mismatch = EXPORT_TO_INIT_EXIT
+},
+/* Do not reference code from writable data */
+{
+	.fromsec = { DATA_SECTIONS, NULL },
+	.tosec   = { TEXT_SECTIONS, NULL },
+	.mismatch = DATA_TO_TEXT
 }
 };
 
@@ -1024,10 +1031,10 @@ static Elf_Sym *find_elf_symbol(struct e
 			continue;
 		if (ELF_ST_TYPE(sym->st_info) == STT_SECTION)
 			continue;
-		if (sym->st_value == addr)
-			return sym;
 		/* Find a symbol nearby - addr are maybe negative */
 		d = sym->st_value - addr;
+		if (d == 0)
+			return sym;
 		if (d < 0)
 			d = addr - sym->st_value;
 		if (d < distance) {
@@ -1268,6 +1275,14 @@ static void report_sec_mismatch(const ch
 		"Fix this by removing the %sannotation of %s "
 		"or drop the export.\n",
 		tosym, sec2annotation(tosec), sec2annotation(tosec), tosym);
+	case DATA_TO_TEXT:
+/*
+		fprintf(stderr,
+		"The variable %s references\n"
+		"the %s %s%s%s\n",
+		fromsym, to, sec2annotation(tosec), tosym, to_p);
+*/
+		break;
 	case NO_MISMATCH:
 		/* To get warnings on missing members */
 		break;
@@ -1651,7 +1666,7 @@ void __attribute__((format(printf, 2, 3)
 	va_end(ap);
 }
 
-void buf_write(struct buffer *buf, const char *s, int len)
+void buf_write(struct buffer *buf, const char *s, unsigned int len)
 {
 	if (buf->size - buf->pos < len) {
 		buf->size += len + SZ;
@@ -1863,7 +1878,7 @@ static void write_if_changed(struct buff
 	if (fstat(fileno(file), &st) < 0)
 		goto close_write;
 
-	if (st.st_size != b->pos)
+	if (st.st_size != (off_t)b->pos)
 		goto close_write;
 
 	tmp = NOFAIL(malloc(b->pos));
diff -urNp linux-2.6.32.24/scripts/mod/modpost.h linux-2.6.32.24/scripts/mod/modpost.h
--- linux-2.6.32.24/scripts/mod/modpost.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/mod/modpost.h	2010-09-04 15:54:52.000000000 -0400
@@ -92,15 +92,15 @@ void *do_nofail(void *ptr, const char *e
 
 struct buffer {
 	char *p;
-	int pos;
-	int size;
+	unsigned int pos;
+	unsigned int size;
 };
 
 void __attribute__((format(printf, 2, 3)))
 buf_printf(struct buffer *buf, const char *fmt, ...);
 
 void
-buf_write(struct buffer *buf, const char *s, int len);
+buf_write(struct buffer *buf, const char *s, unsigned int len);
 
 struct module {
 	struct module *next;
diff -urNp linux-2.6.32.24/scripts/mod/sumversion.c linux-2.6.32.24/scripts/mod/sumversion.c
--- linux-2.6.32.24/scripts/mod/sumversion.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/mod/sumversion.c	2010-09-04 15:54:52.000000000 -0400
@@ -455,7 +455,7 @@ static void write_version(const char *fi
 		goto out;
 	}
 
-	if (write(fd, sum, strlen(sum)+1) != strlen(sum)+1) {
+	if (write(fd, sum, strlen(sum)+1) != (ssize_t)strlen(sum)+1) {
 		warn("writing sum in %s failed: %s\n",
 			filename, strerror(errno));
 		goto out;
diff -urNp linux-2.6.32.24/scripts/pnmtologo.c linux-2.6.32.24/scripts/pnmtologo.c
--- linux-2.6.32.24/scripts/pnmtologo.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/scripts/pnmtologo.c	2010-09-04 15:54:52.000000000 -0400
@@ -237,14 +237,14 @@ static void write_header(void)
     fprintf(out, " *  Linux logo %s\n", logoname);
     fputs(" */\n\n", out);
     fputs("#include <linux/linux_logo.h>\n\n", out);
-    fprintf(out, "static unsigned char %s_data[] __initdata = {\n",
+    fprintf(out, "static unsigned char %s_data[] = {\n",
 	    logoname);
 }
 
 static void write_footer(void)
 {
     fputs("\n};\n\n", out);
-    fprintf(out, "const struct linux_logo %s __initconst = {\n", logoname);
+    fprintf(out, "const struct linux_logo %s = {\n", logoname);
     fprintf(out, "\t.type\t\t= %s,\n", logo_types[logo_type]);
     fprintf(out, "\t.width\t\t= %d,\n", logo_width);
     fprintf(out, "\t.height\t\t= %d,\n", logo_height);
@@ -374,7 +374,7 @@ static void write_logo_clut224(void)
     fputs("\n};\n\n", out);
 
     /* write logo clut */
-    fprintf(out, "static unsigned char %s_clut[] __initdata = {\n",
+    fprintf(out, "static unsigned char %s_clut[] = {\n",
 	    logoname);
     write_hex_cnt = 0;
     for (i = 0; i < logo_clutsize; i++) {
diff -urNp linux-2.6.32.24/security/capability.c linux-2.6.32.24/security/capability.c
--- linux-2.6.32.24/security/capability.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/security/capability.c	2010-09-14 23:49:20.000000000 -0400
@@ -890,7 +890,7 @@ static void cap_audit_rule_free(void *ls
 }
 #endif /* CONFIG_AUDIT */
 
-struct security_operations default_security_ops = {
+struct security_operations default_security_ops __read_only = {
 	.name	= "default",
 };
 
diff -urNp linux-2.6.32.24/security/commoncap.c linux-2.6.32.24/security/commoncap.c
--- linux-2.6.32.24/security/commoncap.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/security/commoncap.c	2010-09-04 15:54:52.000000000 -0400
@@ -27,7 +27,7 @@
 #include <linux/sched.h>
 #include <linux/prctl.h>
 #include <linux/securebits.h>
-
+#include <net/sock.h>
 /*
  * If a non-root user executes a setuid-root binary in
  * !secure(SECURE_NOROOT) mode, then we raise capabilities.
@@ -50,9 +50,11 @@ static void warn_setuid_and_fcaps_mixed(
 	}
 }
 
+extern kernel_cap_t gr_cap_rtnetlink(struct sock *sk);
+
 int cap_netlink_send(struct sock *sk, struct sk_buff *skb)
 {
-	NETLINK_CB(skb).eff_cap = current_cap();
+	NETLINK_CB(skb).eff_cap = gr_cap_rtnetlink(sk);
 	return 0;
 }
 
diff -urNp linux-2.6.32.24/security/integrity/ima/ima_api.c linux-2.6.32.24/security/integrity/ima/ima_api.c
--- linux-2.6.32.24/security/integrity/ima/ima_api.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/security/integrity/ima/ima_api.c	2010-09-04 15:54:52.000000000 -0400
@@ -74,7 +74,7 @@ void ima_add_violation(struct inode *ino
 	int result;
 
 	/* can overflow, only indicator */
-	atomic_long_inc(&ima_htable.violations);
+	atomic_long_inc_unchecked(&ima_htable.violations);
 
 	entry = kmalloc(sizeof(*entry), GFP_KERNEL);
 	if (!entry) {
diff -urNp linux-2.6.32.24/security/integrity/ima/ima_fs.c linux-2.6.32.24/security/integrity/ima/ima_fs.c
--- linux-2.6.32.24/security/integrity/ima/ima_fs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/security/integrity/ima/ima_fs.c	2010-09-04 15:54:52.000000000 -0400
@@ -27,12 +27,12 @@
 static int valid_policy = 1;
 #define TMPBUFLEN 12
 static ssize_t ima_show_htable_value(char __user *buf, size_t count,
-				     loff_t *ppos, atomic_long_t *val)
+				     loff_t *ppos, atomic_long_unchecked_t *val)
 {
 	char tmpbuf[TMPBUFLEN];
 	ssize_t len;
 
-	len = scnprintf(tmpbuf, TMPBUFLEN, "%li\n", atomic_long_read(val));
+	len = scnprintf(tmpbuf, TMPBUFLEN, "%li\n", atomic_long_read_unchecked(val));
 	return simple_read_from_buffer(buf, count, ppos, tmpbuf, len);
 }
 
diff -urNp linux-2.6.32.24/security/integrity/ima/ima.h linux-2.6.32.24/security/integrity/ima/ima.h
--- linux-2.6.32.24/security/integrity/ima/ima.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/security/integrity/ima/ima.h	2010-09-04 15:54:52.000000000 -0400
@@ -84,8 +84,8 @@ void ima_add_violation(struct inode *ino
 extern spinlock_t ima_queue_lock;
 
 struct ima_h_table {
-	atomic_long_t len;	/* number of stored measurements in the list */
-	atomic_long_t violations;
+	atomic_long_unchecked_t len;	/* number of stored measurements in the list */
+	atomic_long_unchecked_t violations;
 	struct hlist_head queue[IMA_MEASURE_HTABLE_SIZE];
 };
 extern struct ima_h_table ima_htable;
diff -urNp linux-2.6.32.24/security/integrity/ima/ima_queue.c linux-2.6.32.24/security/integrity/ima/ima_queue.c
--- linux-2.6.32.24/security/integrity/ima/ima_queue.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/security/integrity/ima/ima_queue.c	2010-09-04 15:54:52.000000000 -0400
@@ -78,7 +78,7 @@ static int ima_add_digest_entry(struct i
 	INIT_LIST_HEAD(&qe->later);
 	list_add_tail_rcu(&qe->later, &ima_measurements);
 
-	atomic_long_inc(&ima_htable.len);
+	atomic_long_inc_unchecked(&ima_htable.len);
 	key = ima_hash_key(entry->digest);
 	hlist_add_head_rcu(&qe->hnext, &ima_htable.queue[key]);
 	return 0;
